/*###########################################################################
#                                                                           #
#                       Header file for xnprintf()                          #
#                                                                           #
#                     public domain (this file only)                        #
#                                                                           #
###########################################################################*/

/*
Revision history:

december 15th 2002 David TAILLANDIER  asnprintf and vasnprintf added

february 16th 2002 David TAILLANDIER  Initial release

*/

#ifndef _XPRINTF_H
#define _XPRINTF_H


#include <stdarg.h>
#include <stdio.h>


int     _nprintf(                     int maxlen, const char * format_string, ... );
int    _vnprintf(                     int maxlen, const char * format_string, va_list vargs );
int    _snprintf( char * dest_string, int maxlen, const char * format_string, ... );
int   _vsnprintf( char * dest_string, int maxlen, const char * format_string, va_list vargs );
int    _fnprintf( FILE * file,        int maxlen, const char * format_string, ... );
int   _vfnprintf( FILE * file,        int maxlen, const char * format_string, va_list vargs );
int    _asprintf( char ** ptr,                    const char * format_string, ... );
int   _vasprintf( char ** ptr,                    const char * format_string, va_list vargs );
int   _asnprintf( char ** ptr,        int maxlen, const char * format_string, ... );
int  _vasnprintf( char ** ptr,        int maxlen, const char * format_string, va_list vargs );


#define    nprintf       _nprintf
#define   vnprintf      _vnprintf
#define   snprintf      _snprintf
#define  vsnprintf     _vsnprintf
#define   fnprintf      _fnprintf
#define  vfnprintf     _vfnprintf
#define   asprintf      _asprintf
#define  vasprintf     _vasprintf
#define  asnprintf     _asnprintf
#define vasnprintf    _vasnprintf


#endif    /* ifndef _XPRINTF_H_ */


/*############################# END OF FILE ###############################*/

